﻿using bachelorAPI_main.Controllers;
using bachelorAPI_main.Data;
using bachelorAPI_main.Handlers;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace bachelorAPI_main.Tests.Base
{
    public abstract class TestBase : IDisposable
    {
        protected ServiceProvider services { get; set; }

        public TestBase()
        {
            var serviceCollection = new ServiceCollection();

            serviceCollection.AddDbContext<DataContext>(options => options.UseSqlite("DataSource=:memory:", x => { }));
            serviceCollection.AddScoped<CommentHandler>();
            serviceCollection.AddScoped<FeedbackHandler>();
            serviceCollection.AddScoped<ModuleHandler>();
            serviceCollection.AddScoped<FeedbackCategoryHandler>();
            serviceCollection.AddScoped<CustomerHandler>();
            serviceCollection.AddTransient<FeedbackController>();

            this.services = serviceCollection.BuildServiceProvider();
        }

        protected DataContext GetContext()
        {
            var ctx = services.GetRequiredService<DataContext>();

            ctx.Database.OpenConnection();
            ctx.Database.EnsureCreated();

            return ctx;
        }

        public void Dispose()
        {
        }
    }
}
