﻿using bachelorAPI_main.Tests.testutils;
using Xunit;
using bachelorAPI_main.Handlers;
using bachelorAPI_main.Models;
using bachelorAPI_main.Tests.Base;

namespace bachelorAPI_main.Tests.Handler
{
    public class CommentHandlerTest : TestBase
    {

        /// <summary>
        /// Passes if comment-list is empty
        /// </summary>
        /// <returns></returns>
        [Fact]
        public async Task GetAllComments_ListIsEmpty()
        {
            var context = GetContext();
            var commentHandler = new CommentHandler(context);

            var result = await commentHandler.GetAllComments();

            Assert.Empty(result);

        }

        /// <summary>
        /// Passes if comment-list is not empty
        /// </summary>
        /// <returns></returns>
        [Fact]
        public async Task GetAllComments_CommentExists()
        {
            var context = GetContext();
            context = TestData.InsertComments(context);

            var commentHandler = new CommentHandler(context);

            var result = await Task.Run(() => commentHandler.GetAllComments());

            Assert.NotEmpty(result);
        }

        /// <summary>
        /// Adds a new Comment to the list
        /// </summary>
        /// <returns></returns>

        [Fact]
        public async Task AddComment_NewComment()
        {
            var context = GetContext();
            var commentHandler = new CommentHandler(context);

            var result = await Task.Run(() => commentHandler.AddComment(new Comment
            {
                CommentSeq = 2,
                CommentText = "This is a second comment"

            }));

            Assert.NotNull(result);
        }


    }

}
