﻿using bachelorAPI_main.Tests.testutils;
using Xunit;
using bachelorAPI_main.Handlers;
using bachelorAPI_main.Models;
using bachelorAPI_main.Tests.Base;

namespace bachelorAPI_main.Tests.Handler
{
    public class FeedbackHandlerTest : TestBase
    {
        /// <summary>
        /// Passes if the feedback-list is empty
        /// </summary>

        [Fact]
        public async Task GetAllFeedbacks_ListEmpty()
        {
            var context = GetContext();
            var feedbackHandler = new FeedbackHandler(context);

            var result = await feedbackHandler.GetAllFeedbacks();

            Assert.Empty(result);
        }

        /// <summary>
        /// Passes if the feedback-list is not empty after adding a new feedback
        /// </summary>
        [Fact]
        public async Task GetAllFeedbacks_AddedElementsExists()
        {
            var context = GetContext();
            context = TestData.InsertFeedbacks(context);

            var feedbackHandler = new FeedbackHandler(context);

            var result = await Task.Run(() => feedbackHandler.GetAllFeedbacks());

            Assert.NotEmpty(result);
        }

        /// <summary>
        /// Passes if a new Feedback elment is added and the reuslt i not null
        /// </summary>
        /// <returns></returns>

        [Fact]
        public async Task AddFeedback_NewFeedback()
        {
            var context = GetContext();
            var feedbackHandler = new FeedbackHandler(context);

            var reuslt = await Task.Run(() => feedbackHandler.AddFeedback(new Feedback()

            {
                FeedbackSeq = 4,
                CategorySeq = 2,
                FeedbackNumber = 5,
                CustomerSeq = 5,
                CommentSeq = 2,
            }));

            Assert.NotNull(reuslt);
        }
    }
}
