﻿using Microsoft.VisualStudio.TestPlatform.ObjectModel.DataCollection;
using bachelorAPI_main.Models;
using System.Reflection;
using bachelorAPI_main.Data;

namespace bachelorAPI_main.Tests.testutils
{
    /// <summary>
    /// Reusable methods for inserting information into tests
    /// </summary>
    public class TestData
    {


        public static Comment CreateComment()
        {
            return new Comment() { CommentText = "BestCommentEver" };
        }

        public static Models.Module CreateModules()
        {
            return new Models.Module()
            {
                ModuleSeq = 1,
                ModuleName = "Basic module",

            };

        }

        /// <summary>
        /// Inserts a Comment into the context
        /// </summary>
        /// <param name="context"></param>
        /// <returns>Datacontext</returns>
        public static DataContext InsertComment(DataContext context)
        {
            context.Comments.Add(CreateComment());
            context.SaveChanges();
            return context;
        }

        /// <summary>
        /// Inserts a Customer into the context
        /// </summary>
        /// <param name="context"></param>
        /// <returns>Datacontext</returns>

        public static DataContext InsertCustomers(DataContext context)
        {
            context.Customers.Add(new Customer
            {
                CustomerSeq = 10014,
                OrganizationNumber = "123 456 789",
                CustomerName = "Customer1",
                CustomerSince = DateTime.Now,
                UserSeq = 1
            });
            context.Customers.Add(new Customer
            {
                CustomerSeq = 10015,
                OrganizationNumber = "111 111 111",
                CustomerName = "Customer2",
                CustomerSince = DateTime.Now,
                UserSeq = 1

            });
            context.SaveChanges();
            return context;
        }

        /// <summary>
        /// Adds a ModuleLevel to an Module with a FK
        /// </summary>
        /// <param name="context">DataContext</param>
        /// <returns>DataContext</returns>
        public static DataContext InsertModule(DataContext context)
        {

            context.Modules.Add(CreateModules());
            context.SaveChanges();
            return context;
        }

        /// <summary>
        /// Inserts a feedbackcatagory
        /// </summary>
        /// <param name="context"></param>
        /// <returns>Datacontext</returns>
        public static DataContext InsertFeedbackCatagory(DataContext context)
        {
            context.FeedbackCategories.Add(new FeedbackCategory
            {
                FeedbackCategorySeq = 1,
                FeedbackCategoryName = "Brukervurdering",
                MainFeedbackCategorySeq = 2
            });

            context.SaveChanges();
            return context;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns>Datacontext</returns>

        public static DataContext InsertComments(DataContext context)
        {
            context.Comments.Add(new Comment
            {
                CommentSeq = 4,
                CommentText = "This is a comment"

            });
            context.SaveChanges();
            return context;
        }


        /// <summary>
        /// Inserts a feedback into the context
        /// </summary>
        /// <param name="context"></param>
        /// <returns>Datacontext</returns>


        public static DataContext InsertFeedbacks(DataContext context)
        {
            context.Feedbacks.Add(new Feedback
            {
                FeedbackSeq = 1,
                CategorySeq = 1,
                FeedbackNumber = 5,
                CustomerSeq = 10014,
                CommentSeq = 4,
                ModuleSeq = 1

            });

            context.SaveChanges();
            return context;
        }


    }
}
