﻿using System.ComponentModel.DataAnnotations.Schema;
using System.ComponentModel.DataAnnotations;
using bachelorAPI_main.Models;

namespace bachelorAPI_main.DTOs
{

    public enum FeedbackNumberEnum
    {
        Worst,
        Bad,
        Neutral,
        Good,
        Great,
    }
    /// <summary>
    /// Data transfer object for new feedback requests. Avoids over posting.
    /// </summary>
    public class DTOFeedbackNewRequest 
    {
        [SwaggerSchemaExample("10014")]
        [Required]
        public int CustomerSeq { get; set; }

        [SwaggerSchemaExample("2")]
        [Required]
        public FeedbackNumberEnum FeedbackNumber { get; set; }

        [SwaggerSchemaExample("This is a comment")]
        public string? CommentText { get; set; }

        [SwaggerSchemaExample("2")]
        [Required]
        public int CategorySeq { get; set; }

        [SwaggerSchemaExample("1")]
        [Required]
        public int ModuleSeq { get; set; }
    }

    /// <summary>
    /// Data transfer object for feedback response. Avoids unnecessary parameters.
    /// </summary>
    public class DTOFeedbackResponse : DTOResponseBase
    {
        [SwaggerSchemaExample("1")]
        [Required]
        public int FeedbackSeq { get; set; }

    }


    public class DTOFeedbackGetResponse : DTOResponseBase
    {
        public IList<Feedback>? feedbacks { get; set; }
    }
}
