﻿using bachelorAPI_main.Data;
using bachelorAPI_main.Models;
using Microsoft.EntityFrameworkCore;

namespace bachelorAPI_main.Handlers
{
    public class CustomerHandler
    {

        private readonly DataContext _db;

       public CustomerHandler(DataContext db)
        {
            _db = db;   
        }

        /// <summary>
        /// Gets alle the customers from the database
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public async Task<List<Customer>> GetAllCustomers(int? id = null)
        {
            var res = await _db.Customers
                       .Where(c => id == null || c.CustomerSeq == id).Select(c => new Customer
                       {
                           CustomerSeq = c.CustomerSeq,
                           CustomerName= c.CustomerName,
                       })
                       .ToListAsync();

            return res;
        }

     
    }
}
