﻿using bachelorAPI_main.Data;
using bachelorAPI_main.Models;
using Microsoft.EntityFrameworkCore;

namespace bachelorAPI_main.Handlers
{
    public class FeedbackCategoryHandler
    {

        private readonly DataContext _db;

        public FeedbackCategoryHandler(DataContext db) { _db = db; }

        /// <summary>
        /// Gets all the FeedbackCatagories from the database
        /// </summary>
        /// <param name="id"></param>
        /// <returns>A list of feedbackCatagories</returns>
        public async Task<List<FeedbackCategory>> GetAllMFeedbackCatagories(int? id = null)
        {
            var res = await _db.FeedbackCategories
                       .Where(fbc => id == null || fbc.FeedbackCategorySeq == id)
                       .ToListAsync();

            return res;
        }

    }
}
