﻿using bachelorAPI_main.Data;

using bachelorAPI_main.Models;
using Microsoft.EntityFrameworkCore;

namespace bachelorAPI_main.Handlers
{
    public class FeedbackHandler
    {
        private readonly DataContext _db;
           
          public FeedbackHandler(DataContext db)
        {
            _db = db;   
        } 

        /// <summary>
        /// Gets all the feedbacks from the database
        /// </summary>
        /// <param name="id"></param>
        /// <returns>A list of feedbacks</returns>
        public async Task<List<Feedback>> GetAllFeedbacks(int? id = null)
        {
            var res = await _db.Feedbacks
                .Where(f => id == null || f.FeedbackSeq== id)
                .ToListAsync();

            return res;
        }

        /// <summary>
        /// Adds a feedback to the database
        /// </summary>
        /// <param name="feedback"></param>
        /// <returns>The added feedback to the database </returns>
        public async Task<Feedback> AddFeedback(Feedback feedback)
        {   
           
            var res = await _db.AddAsync(feedback);

            await _db.SaveChangesAsync();
            _db.ChangeTracker.Clear();


            return res.Entity;
        }



    }
}
