﻿using bachelorAPI_main.Data;
using bachelorAPI_main.Models;
using Microsoft.EntityFrameworkCore;
using Microsoft.IdentityModel.Tokens;

namespace bachelorAPI_main.Handlers
{
    public class ModuleHandler
    {
        private readonly DataContext _db;
        

        public ModuleHandler(DataContext db)
        {
            _db = db;
        }

        /// <summary>
        /// Gets all Modules from the database
        /// </summary>
        /// <returns>A list of all modules</returns>
        public async Task<List<Module>> GetAllModules()
        {   
            
            var res = await _db.Modules
                       .Where(m => m.IsActive == true || m.IsActive != null)
                       .ToListAsync();

            return res;
        }

    }
}
