﻿using Org.BouncyCastle.Crypto.Agreement;
using System.ComponentModel.DataAnnotations.Schema;
using System.ComponentModel.DataAnnotations;
using System.Drawing;

namespace bachelorAPI_main.Models
{
    public class Customer
    {
        [Key]
        public int CustomerSeq { get; set; }

        [Required]
        [MaxLength(11)]
        public string OrganizationNumber { get; set; }

        [Required]
        [MaxLength(50)]
        public string CustomerName { get; set; }

        public int? LedgerNumber { get; set; }

        [MaxLength(100)]
        public string? Connection { get; set; }

        [MaxLength(50)]
        public string? DBName { get; set; }

        [MaxLength(50)]
        public string? CustomerUsername { get; set; }

        [MaxLength(50)]
        public string? CustomerPassword { get; set; }

        [MaxLength(50)]
        public string? API { get; set; }

        [Required]
        public DateTime? CustomerSince { get; set; }

        public bool? IsActive { get; set; }

        [ForeignKey("Priority")]
        public int? PrioritySeq { get; set; }

        [ForeignKey("Segment")]
        public int? SegmentSeq { get; set; }

        [ForeignKey("Region")]
        public int? RegionSeq { get; set; }
        [Required]
        [ForeignKey("User")]
        public int? UserSeq { get; set; }

        public DateTime? lastCustomerMeeting { get; set; }

        public String? ReportsConnection { get; set; }

        public String? ReportsPassword { get; set; }
    }
}
