﻿using System.ComponentModel.DataAnnotations.Schema;
using System.ComponentModel.DataAnnotations;
using System.Reflection;
using Microsoft.EntityFrameworkCore;

namespace bachelorAPI_main.Models
{

    public class Feedback
    {
        [SwaggerSchemaExample("1")]
        [Key]
        public int FeedbackSeq { get; set; }

        [SwaggerSchemaExample("10014")]
        [ForeignKey("Customer")]
        public int CustomerSeq { get; set; }

        [SwaggerSchemaExample("5")]

        [Required]
        public double FeedbackNumber { get; set; }

        [SwaggerSchemaExample("4")]

        [ForeignKey("Comment")]
        public int? CommentSeq { get; set; }

        [SwaggerSchemaExample("7")]

        [ForeignKey("Categories")]
        public int CategorySeq { get; set; }

        [SwaggerSchemaExample("3")]

        [ForeignKey("Module")]
        public int ModuleSeq { get; set; }

        public DateTime? FeedbackSince { get; set; }

    }
}
